void setup() {
  size(500, 500);
}

void draw() {
  background(255);
  Triangle t = new Triangle();
  t.x = mouseX; 
  t.y = mouseY;
  t.angle = TWO_PI*millis()/1000;
  t.expansion = 50;
  t.draw();

  for (int i = 0; i < triangles.size(); i++) {
    Triangle t2 = (Triangle) triangles.get(i);
    t2.step();
    t2.draw();
  }
}

ArrayList triangles = new ArrayList();

void mousePressed() {
  Triangle t = new Triangle();
  t.x = mouseX; 
  t.y = mouseY;
  t.vx = -100*(pmouseX - mouseX);
  t.vy = -100*(pmouseY - mouseY);
  t.angle = TWO_PI*millis()/1000;
  t.expansion = 50;
  t.c = color(random(255), 255, 255);
  triangles.add(t);
}

class Triangle {
  float x, y;
  float vx = 0, vy = 0;
  float angle;
  float expansion;
  float offset = random(TWO_PI);
  color c;

  void draw() {
    smooth();
    colorMode(HSB, 255, 255, 255);
    fill(c);
    noStroke();
    ellipse(x, y, expansion, expansion);
//    myTriangle(x, y, angle, expansion);
  }

  float lastMs = millis();
  void step() {
    for (int i = 0; i < triangles.size(); ++i) {
      Triangle other = (Triangle) triangles.get(i);
      float d = sqrt(pow(x - other.x, 2)+pow(y - other.y, 2));
      if (d < expansion/2+other.expansion/2) {
        vx = -vx;
        vy = -vy;
        other.vx = -other.vx;
        other.vy = -other.vy;
      }
    }
    expansion -= .1;
    if (expansion < 0) triangles.remove(this);
    float ms = millis();
    angle = offset+TWO_PI*ms/1000;
    vy += (1000)*(ms - lastMs)/1000;
    y += vy*(ms-lastMs)/1000;
    x += vx*(ms-lastMs)/1000;

    if (y > height-expansion/2) {
      y = height-expansion/2;
      vy = -vy/sqrt(2);
      vx = vx/sqrt(2);
    }
    if (x > width-expansion/2) {
      x = width-expansion/2;
      vx = -vx/sqrt(2);
    }
    if (x < 0+expansion/2) {
      x = 0+expansion/2;
      vx = -vx/sqrt(2);
    }
    lastMs = ms;
  }
}

// line from (50, 50) to (200, 200)
// (150, 150)
void myLine(float x1, float y1, float x2, float y2) {
  float slope = (float) (y2-y1) / (float) (x2-x1);
  for (float i = 0; i <= (x2-x1); i += (abs(slope) > 1 ? 1/abs(slope) : 1)) {
    float ypt = slope*(i)+y1;
    point(i+x1, ypt);
  }
}

void myTriangle(float x1, float y1, float angle, float expansion) {
  // expansion -> height of the triangle
  // base's length will be expansion/2
  pushMatrix();
  translate(x1, y1);
  rotate(angle);
  smooth();
  line(-expansion/4, expansion/2, expansion/4, expansion/2);
  line(-expansion/4, expansion/2, 0, -expansion/2);
  line(0, -expansion/2, expansion/4, expansion/2);
  popMatrix();
}

